program	TileDecoders;					{$APPTYPE Console}
uses	AnsiStrings, Classes, SysUtils;


//	This program generates the tile decoders. It produces unrolled code that
//	should be easy to manage by the execution pipeline of today's processors.
//
//	".\input\xx.pas" is the template containing code for 8 pixels. It is
//	repeated 8 times to generate the code for an entire tile (8x8 pixels).
//
//	The character # is used to indicate the line index.


const	CRLF		=	#13#10;


	Header		=	'procedure TileDecoder#(var PackedTile, DestTile);'			+ CRLF +
				'var	Src		:	TPackedTile# absolute PackedTile;'	+ CRLF +
				'	Dest		:	TTile absolute DestTile;'		+ CRLF +
				'begin';


	Names		:	array[1..7] of String
			=	('1', '2', '3', '4', '7i', '7n', '8');


var	AppPath		:	String;
	Dest		:	TStringList;
	i		:	Integer;
	Line		:	Integer;
	Src		:	TStringList;


function StringReplace(const Text : String;  const old, new : String) : String;
var	i		:	Integer;
begin
Result := Text;
i := 1;
while (i <= Length(Text)) do begin
	i := PosEx(AnsiString(old), AnsiString(Result), i);
	if (i = 0) then Break;
	Delete(Result, i, Length(old));
	Insert(new, Result, i);
	Inc(i, Length(new));
end
end;


begin
AppPath	:= ExtractFilePath(ParamStr(0));
Dest	:= TStringList.Create;
Src	:= TStringList.Create;
for i := 1 to 7 do begin
	Dest.Add(StringReplace(Header, '#', Names[i]));
	Src.LoadFromFile(AppPath + 'input\' + Names[i] + '.pas');
	for Line := 0 to 7 do  Dest.Add(StringReplace(Src.Text, '#', IntToStr(Line)));
	Dest.Add('end;');
	Dest.SaveToFile(AppPath + 'output\' + Names[i] + '.pas');
	Dest.Clear;
end;
Dest.Free;
Src .Free;
end.
